package app.views.results;

import app.data.entity.Game;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.component.html.Image;
import app.data.entity.Match;
import app.image.ImageService;
import app.navigation.Navigation;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class MatchView extends VerticalLayout {

    private final ResultsView parent;
    private final Navigation navigation;
    private final List<Image> images = new ArrayList<>();

    private final ImageService imageService;

//    private final ChessComService chessComService;
//    private final PlayerService playerService;

    //    public ResultsViewRight(@Autowired ChessComService chessComService, @Autowired PlayerService playerService) {
    public MatchView(Navigation navigation, ResultsView resultsView, @Autowired ImageService imageService) {
        this.parent = resultsView;
        this.navigation = navigation;
        this.imageService = imageService;

        navigation.addRunnableToBeRunAfterMatchSelection(this::configureContent);
        navigation.addRunnableToBeRunAfterMatchSelection(this::configureParentSplit);
//        this.chessComService = chessComService;
//        this.playerService = playerService;
    }

    private void configureParentSplit() {
        navigation.getSelectedMatch().ifPresentOrElse(
                match -> parent.enableSplit(),
                parent::disableSplit
        );
    }

    private void configureContent() {
        Match match = navigation.getSelectedMatch().orElseThrow();

        removeAll();
        for (Game game : match.getGames()) {
            Image image = new Image(imageService.getVaadinImagePath(game).orElse(""), "image");
//            Image img = new Image()
//            image.setWidth(200, Unit.PIXELS);
//            image.setHeight(200, Unit.PIXELS);
            image.setWidth("30%");
//            image.setHeight("30%");
            add(image);
        }
//
//        images.addAll(match.getGames().stream()
//                .map(game -> new Image(imageService.getImagePath(game).orElse(""), "app/image"))
//                .collect(Collectors.toList()));
//        images.forEach(this::add);
    }

}
